<!-- This file was generated by pybib2web, version 0.7.dev0: https://gitlab.com/sosy-lab/software/pybib2web/ -->
<input type="checkbox" id="show-compact">
<label for="show-compact">Compact view</label>
<h2 id="publications">Publications of year 2003</h2>
<nav class="publication-navigation">(<a href="../All/index.html">Show all</a> &ndash; <a href="../index.html">Index</a>)</nav>

<a href="../Category/conferences.html"><h3>Articles in conference or workshop proceedings</h3></a>

<ol class="list-publications" start="1">

<li class="bibentry" id="WCRE03">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Andreas</span> <span class="lastname">Noack</span></span>, and
    <span class="author"><span class="firstname">Claus</span> <span class="lastname">Lewerentz</span></span>.</span>
    <span class="publication-title">Simple and Efficient Relational Querying
    of Software Structures.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the Tenth IEEE Working Conference on
        Reverse Engineering (WCRE 2003, Victoria, BC, November 13-16)</em>,
      <span class="pages">pages 216-225</span>,
      <span class="publication-date">  <span class="year">2003</span></span>.
    </span>
    <span class="publisher">IEEE Computer Society Press, Los Alamitos (CA).</span>
    <a class="doi" href="https://doi.org/10.1109/WCRE.2003.1287252" data-doi="10.1109/WCRE.2003.1287252" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1109/WCRE.2003.1287252</a>
  </span>
  <a class="bibentry-link" href="#WCRE03"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/STRUCTURAL-ANALYSIS-AND-COMPREHENSION.html">Structural Analysis and Comprehension</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1109/WCRE.2003.1287252" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2003-WCRE.Simple_and_Efficient_Relational_Querying_of_Software_Structures.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="material-link" href="http://www.sosy-lab.org/~dbeyer/CrocoPat/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Many analyses of software systems can be formalized as
        relational queries, for example the detection of
        design patterns, of patterns of problematic design, of
        code clones, of dead code, and of differences between
        the as-built and the as-designed architecture.  This
        paper describes the concepts of CrocoPat, a tool for
        querying and manipulating relations.  CrocoPat is easy
        to use, because of its simple query and manipulation
        language based on predicate calculus, and its simple
        file format for relations.  CrocoPat is efficient,
        because it internally represents relations as binary
        decision diagrams, a data structure that is well-known
        as a compact representation of large relations in
        computer-aided verification. CrocoPat is general,
        because it manipulates not only graphs (i.e. binary
        relations), but n-ary relations.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{WCRE03,
        author = {Dirk Beyer and Andreas Noack and Claus Lewerentz},
        title = {Simple and Efficient Relational Querying of Software Structures},
        booktitle = {Proceedings of the Tenth IEEE Working Conference on Reverse Engineering (WCRE~2003, Victoria, BC, November 13-16)},
        pages = {216-225},
        year = {2003},
        publisher = {IEEE Computer Society Press, Los Alamitos~(CA)},
        isbn = {0-7695-2027-8},
        doi = {10.1109/WCRE.2003.1287252},
        url = {http://www.sosy-lab.org/~dbeyer/CrocoPat/},
        pdf = {https://www.sosy-lab.org/research/pub/2003-WCRE.Simple_and_Efficient_Relational_Querying_of_Software_Structures.pdf},
        abstract = {Many analyses of software systems can be formalized as relational queries, for example the detection of design patterns, of patterns of problematic design, of code clones, of dead code, and of differences between the as-built and the as-designed architecture.  This paper describes the concepts of CrocoPat, a tool for querying and manipulating relations.  CrocoPat is easy to use, because of its simple query and manipulation language based on predicate calculus, and its simple file format for relations.  CrocoPat is efficient, because it internally represents relations as binary decision diagrams, a data structure that is well-known as a compact representation of large relations in computer-aided verification. CrocoPat is general, because it manipulates not only graphs (i.e. binary relations), but n-ary relations.},
        keyword = {Structural Analysis and Comprehension},
        annote = {CrocoPat&#x27;s concepts, an introduction to the BDD-based implementation, software analysis applications, and performance measurements.&lt;BR&gt;},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        
        CrocoPat's concepts, an introduction to the
        BDD-based implementation, software analysis applications,
        and performance measurements.<BR>
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="FORTE03">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><span class="firstname">Andreas</span> <span class="lastname">Noack</span></span>.</span>
    <span class="publication-title">Can Decision Diagrams Overcome State Space Explosion
    in Real-Time Verification?.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">H.</span> <span class="lastname">König</span></span>,
      <span class="editor"><span class="firstname">M.</span> <span class="lastname">Heiner</span></span>, and
      <span class="editor"><span class="firstname">A.</span> <span class="lastname">Wolisz</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 23rd IFIP International Conference on
        Formal Techniques for Networked and Distributed Systems
        (FORTE 2003, Berlin, September 29 - October 2)</em>,
      <span class="series">LNCS 2767</span>,
      <span class="pages">pages 193-208</span>,
      <span class="publication-date">  <span class="year">2003</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-39979-7_13" data-doi="10.1007/978-3-540-39979-7_13" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-39979-7_13</a>
  </span>
  <a class="bibentry-link" href="#FORTE03"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/FORMAL-VERIFICATION-OF-REAL-TIME-SYSTEMS.html">Formal Verification of Real-Time Systems</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-39979-7_13" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2003-FORTE.Can_Decision_Diagrams_Overcome_State_Space_Explosion_in_Real-Time_Verification.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        In this paper we analyze the efficiency of binary
        decision diagrams (BDDs) and clock difference diagrams
        (CDDs) in the verification of timed automata.
        Therefore we present analytical and empirical
        complexity results for three communication
        protocols. The contributions of the analyses are:
        Firstly, they show that BDDs and CDDs of polynomial
        size exist for the reachability sets of the three
        protocols. This is the first evidence that CDDs can
        grow only polynomially for models with non-trivial
        state space explosion. Secondly, they show that
        CDD-based tools, which currently use at least
        exponential space for two of the protocols, will only
        find polynomial-size CDDs if they use better variable
        orders, as the BDD-based tool Rabbit does. Finally,
        they give insight into the dependency of the BDD and
        CDD size on properties of the model, in particular the
        number of automata and the magnitude of the clock
        values.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{FORTE03,
        author = {Dirk Beyer and Andreas Noack},
        title = {Can Decision Diagrams Overcome State Space Explosion in Real-Time Verification?},
        booktitle = {Proceedings of the 23rd IFIP International Conference on Formal Techniques for Networked and Distributed Systems (FORTE~2003, Berlin, September 29 - October 2)},
        editor = {H.~K{\&quot;o}nig and M.~Heiner and A.~Wolisz},
        pages = {193-208},
        year = {2003},
        series = {LNCS~2767},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {3-540-20175-0},
        doi = {10.1007/978-3-540-39979-7_13},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2003-FORTE.Can_Decision_Diagrams_Overcome_State_Space_Explosion_in_Real-Time_Verification.pdf},
        abstract = {In this paper we analyze the efficiency of binary decision diagrams (BDDs) and clock difference diagrams (CDDs) in the verification of timed automata. Therefore we present analytical and empirical complexity results for three communication protocols. The contributions of the analyses are: Firstly, they show that BDDs and CDDs of polynomial size exist for the reachability sets of the three protocols. This is the first evidence that CDDs can grow only polynomially for models with non-trivial state space explosion. Secondly, they show that CDD-based tools, which currently use at least exponential space for two of the protocols, will only find polynomial-size CDDs if they use better variable orders, as the BDD-based tool Rabbit does. Finally, they give insight into the dependency of the BDD and CDD size on properties of the model, in particular the number of automata and the magnitude of the clock values.},
        keyword = {Formal Verification of Real-Time Systems},
        annote = {Analysis of the efficiency of binary decision diagrams (BDDs) and clock difference diagrams (CDDs) in the verification of timed automata. Analytical and empirical complexity results for three communication protocols.},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        
        Analysis of the efficiency of binary decision diagrams (BDDs)
        and clock difference diagrams (CDDs) in the verification
        of timed automata. Analytical and empirical complexity
        results for three communication protocols.
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="CAV03">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Claus</span> <span class="lastname">Lewerentz</span></span>, and
    <span class="author"><span class="firstname">Andreas</span> <span class="lastname">Noack</span></span>.</span>
    <span class="publication-title">Rabbit: A Tool for BDD-Based Verification
    of Real-Time Systems.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">W. A.</span> <span class="lastname">Hunt</span></span> and
      <span class="editor"><span class="firstname">F.</span> <span class="lastname">Somenzi</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 15th International Conference on
        Computer Aided Verification (CAV 2003, Boulder, CO, July 8-12)</em>,
      <span class="series">LNCS 2725</span>,
      <span class="pages">pages 122-125</span>,
      <span class="publication-date">  <span class="year">2003</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-45069-6_13" data-doi="10.1007/978-3-540-45069-6_13" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-45069-6_13</a>
  </span>
  <a class="bibentry-link" href="#CAV03"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/FORMAL-VERIFICATION-OF-REAL-TIME-SYSTEMS.html">Formal Verification of Real-Time Systems</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-45069-6_13" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2003-CAV.Rabbit_A_Tool_for_BDD-Based_Verification_of_Real-Time_Systems.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        This paper gives a short overview of a model checking
        tool for real-time systems. The modeling language are
        timed automata extended with concepts for modular
        modeling. The tool provides reachability analysis and
        refinement checking, both implemented using the data
        structure BDD. Good variable orderings for the BDDs
        are computed from the modular structure of the model
        and an estimate of the BDD size. This leads to a
        significant performance improvement compared to the
        tool RED and the BDD-based version of Kronos.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{CAV03,
        author = {Dirk Beyer and Claus Lewerentz and Andreas Noack},
        title = {Rabbit: A Tool for {BDD}-Based Verification of Real-Time Systems},
        booktitle = {Proceedings of the 15th International Conference on Computer Aided Verification (CAV~2003, Boulder, CO, July 8-12)},
        editor = {W.~A.~Hunt and F.~Somenzi},
        pages = {122-125},
        year = {2003},
        series = {LNCS~2725},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {3-540-40524-0},
        doi = {10.1007/978-3-540-45069-6_13},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2003-CAV.Rabbit_A_Tool_for_BDD-Based_Verification_of_Real-Time_Systems.pdf},
        abstract = {This paper gives a short overview of a model checking tool for real-time systems. The modeling language are timed automata extended with concepts for modular modeling. The tool provides reachability analysis and refinement checking, both implemented using the data structure BDD. Good variable orderings for the BDDs are computed from the modular structure of the model and an estimate of the BDD size. This leads to a significant performance improvement compared to the tool RED and the BDD-based version of Kronos.},
        keyword = {Formal Verification of Real-Time Systems},
        annote = {Online: &lt;a href=&quot;http://springerlink.metapress.com/openurl.asp?genre=article&amp;issn=0302-9743&amp;volume=2725&amp;spage=122&quot;&gt; http://springerlink.metapress.com/openurl.asp?genre=article&amp;issn=0302-9743&amp;volume=2725&amp;spage=122&lt;/a&gt; &lt;BR&gt; A description of the BDD-based tool&#x27;s main features.},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        
        Online:
        <a href="http://springerlink.metapress.com/openurl.asp?genre=article&issn=0302-9743&volume=2725&spage=122">
        http://springerlink.metapress.com/openurl.asp?genre=article&issn=0302-9743&volume=2725&spage=122</a> <BR>
        A description of the BDD-based tool's main features.
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="IWPC03">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span> and
    <span class="author"><span class="firstname">Claus</span> <span class="lastname">Lewerentz</span></span>.</span>
    <span class="publication-title">CrocoPat: Efficient Pattern Analysis
    in Object-Oriented Programs.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 11th IEEE International Workshop on
        Program Comprehension (IWPC 2003, Portland, OR, May 10-11)</em>,
      <span class="pages">pages 294-295</span>,
      <span class="publication-date">  <span class="year">2003</span></span>.
    </span>
    <span class="publisher">IEEE Computer Society Press, Los Alamitos (CA).</span>
    <a class="doi" href="https://doi.org/10.1109/WPC.2003.1199220" data-doi="10.1109/WPC.2003.1199220" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1109/WPC.2003.1199220</a>
  </span>
  <a class="bibentry-link" href="#IWPC03"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/STRUCTURAL-ANALYSIS-AND-COMPREHENSION.html">Structural Analysis and Comprehension</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1109/WPC.2003.1199220" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2003-IWPC.CrocoPat_Efficient_Pattern_Analysis_in_Object-Oriented_Programs.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="material-link" href="http://www.sosy-lab.org/~dbeyer/CrocoPat/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Automatic pattern-based recognition of design weakness
        is a research topic since almost 10 years. Reports
        about experiments with existing approaches reveal two
        major problems: A notation for easy and flexible
        specification of the pattern is missing; only a
        restricted set of patterns is applicable because of
        the limitations of the specification language.
        Performance improvement is needed, because the
        computation time of existing tools is to high to be
        acceptable for large real-world systems.
        <BR>
        The tool CrocoPat satisfies the following three
        requirements: (1) The analysis is done automatically
        by the tool, i.e. without user interaction.  (2) The
        properties of a system are specified in an easy and
        flexible way because the patterns are described by
        relational expressions. On demand the user is able to
        define new patterns he is interested in, or to change
        existing patterns to solve specific problems.  (3) The
        tool is able to analyze large object-oriented programs
        (1'000 to 10'000 classes) in acceptable time.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{IWPC03,
        author = {Dirk Beyer and Claus Lewerentz},
        title = {{{\sc CrocoPat}}: Efficient Pattern Analysis in Object-Oriented Programs},
        booktitle = {Proceedings of the 11th IEEE International Workshop on Program Comprehension (IWPC~2003, Portland, OR, May 10-11)},
        pages = {294-295},
        year = {2003},
        publisher = {IEEE Computer Society Press, Los Alamitos~(CA)},
        isbn = {0-7695-1883-4},
        doi = {10.1109/WPC.2003.1199220},
        url = {http://www.sosy-lab.org/~dbeyer/CrocoPat/},
        pdf = {https://www.sosy-lab.org/research/pub/2003-IWPC.CrocoPat_Efficient_Pattern_Analysis_in_Object-Oriented_Programs.pdf},
        abstract = {Automatic pattern-based recognition of design weakness is a research topic since almost 10 years. Reports about experiments with existing approaches reveal two major problems: A notation for easy and flexible specification of the pattern is missing; only a restricted set of patterns is applicable because of the limitations of the specification language. Performance improvement is needed, because the computation time of existing tools is to high to be acceptable for large real-world systems. &lt;BR&gt; The tool CrocoPat satisfies the following three requirements: (1) The analysis is done automatically by the tool, i.e. without user interaction.  (2) The properties of a system are specified in an easy and flexible way because the patterns are described by relational expressions. On demand the user is able to define new patterns he is interested in, or to change existing patterns to solve specific problems.  (3) The tool is able to analyze large object-oriented programs (1&#x27;000 to 10&#x27;000~classes) in acceptable time.},
        keyword = {Structural Analysis and Comprehension},
        annote = {Introduction of a BDD-based tool for pattern analysis and a short overview of the main features of CrocoPat.},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        Introduction of a BDD-based tool for pattern analysis
        and a short overview of the main features of CrocoPat.
        
      </div>
    </details>
  </span>
</li>

</ol>
 <section id="disclaimer"> <h4>Disclaimer:</h4> <p class="disclaimer"> This material is presented to ensure timely dissemination of scholarly and technical work. Copyright and all rights therein are retained by authors or by other copyright holders. All person copying this information are expected to adhere to the terms and constraints invoked by each author's copyright. In most cases, these works may not be reposted without the explicit permission of the copyright holder. </p> </section> <footer id="generator">This file was generated by <a href="https://gitlab.com/sosy-lab/software/pybib2web/">pybib2web</a>, version 0.7.dev0</footer>